#include "gps_packet.h"

/*
 * The following are debugging functions, they print
 * the values of each channel's field to a file pointer
 */
void print_gps_timestamp(gps_timestamp *timestamp)
{
	printf("UTC Time: %d:%d:%f\n", timestamp->hour, timestamp->minute, (float)timestamp->second + 1e-4*(float)timestamp->hundred_microsecond);
	printf("UTC Date: %d, %d, %d\n", timestamp->month, timestamp->day, timestamp->year);
}

void print_gps_timestamp(gps_timestamp *timestamp, uint8ptr buffer)
{
	sprintf(buffer, "UTC Time: %d:%d:%f\nUTC Date: %d, %d, %d\n",
			timestamp->hour, timestamp->minute, (float)timestamp->second + 1e-4*(float)timestamp->hundred_microsecond,
			timestamp->month, timestamp->day, timestamp->year);
}

void print_gps_f00(gps_f00 *f00)
{
	printf("UTC Time: %d:%d:%f\n", f00->hour, f00->minute, (float)f00->second);
	printf("UTC Date: %d, %d, %d\n", f00->month, f00->day, f00->year);
	printf("Position: %f %f %f\n", f00->ecef_pos_x, f00->ecef_pos_y, f00->ecef_pos_z);
	printf("Velocity: %f %f %f\n", f00->ecef_vel_x, f00->ecef_vel_y, f00->ecef_vel_z);
	printf("G P V dop: %f %f %f\n", f00->gdop, f00->pdop, f00->vdop);
	printf("Doppler Shift from Clock: %f\n", f00->dopp_from_clk);
	printf("Navigation Mode: %d\n", (int)f00->navmode);
	printf("Number of Satelites: %d\n", (int)f00->numsats);
	printf("Tracking Type: %d\n", (int)f00->tracktype);
	printf("Time Type: %d\n", (int)f00->time_type);
	printf("System Status: %d\n", (int)f00->system_status);
	printf("Seconds: %f\n", (float)f00->Second2 + 1e-3*(float)f00->DeSecond);
	printf("GPS Week:Seconds: %d:%f\n", f00->GPS_week, (float)f00->GPS_sec);
}

void sprint_gps_f00(gps_f00 *f00, uint8ptr buffer)
{
	sprintf(buffer, "UTC Time: %d:%d:%f\nUTC Date: %d, %d, %d\nPosition: %f %f %f\nVelocity: %f %f %f\nG P V dop: %f %f %f\nDoppler Shift from Clock: %f\nNavigation Mode: %d\nNumber of Satelites: %d\nTracking Type: %d\nTime Type: %d\nSystem Status: %d\nSeconds: %f\nGPS Week:Seconds: %d:%f\n",
				f00->hour, f00->minute, (float)f00->second,
				f00->month, f00->day, f00->year,
				f00->ecef_pos_x, f00->ecef_pos_y, f00->ecef_pos_z,
				f00->ecef_vel_x, f00->ecef_vel_y, f00->ecef_vel_z,
				f00->gdop, f00->pdop, f00->vdop,
				f00->dopp_from_clk,
				(int)f00->navmode,
				(int)f00->numsats,
				(int)f00->tracktype,
				(int)f00->time_type,
				(int)f00->system_status,
				(float)f00->Second2 + 1e-3*(float)f00->DeSecond,
				f00->GPS_week, (float)f00->GPS_sec);
}

void print_gps_f03(gps_f03 *f03)
{
	uint8 x;

	printf("CdLI:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->CdLI[x]);
	printf("\n");

	printf("dopp:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->dopp[x]);
	printf("\n");

	printf("azi:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->azi[x]);
	printf("\n");

	printf("cnr:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->cnr[x]);
	printf("\n");

	printf("dispsy:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->dispsv[x]);
	printf("\n");

	printf("elv:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->elv[x]);
	printf("\n");

	printf("statflag:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->statflag[x]);
	printf("\n");

	printf("codeelk:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->codeelk[x]);
	printf("\n");

	printf("carrlk:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->carrlk[x]);
	printf("\n");

	printf("bitlk:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->bitlk[x]);
	printf("\n");

	printf("framelk:");
	for (x = 0; x < 12; x++)
		printf(" %d", f03->framelk[x]);
	printf("\n");
}

void print_gps_f18(gps_f18 *f18)
{
	uint8 x;

	printf("range:");
	for (x = 0; x < 12; x++)
		printf(" %f", f18->range[x]);
	printf("\n");

	printf("phase:");
	for (x = 0; x < 12; x++)
		printf(" %f", f18->phase[x]);
	printf("\n");
}

void print_gps_f22(gps_f22 *f22)
{
	printf("almsqrta: %d\n", f22->almsqrta);
	printf("ratoa: %d\n", f22->ratoa);
	printf("argpg: %d\n", f22->argpg);
	printf("manom: %d\n", f22->manom);
	printf("ephecc: %d\n", f22->ephecc);
	printf("ephsqrta: %d\n", f22->ephsqrta);
	printf("m0: %d\n", f22->m0);
	printf("om0: %d\n", f22->om0);
	printf("in0: %d\n", f22->in0);
	printf("olc: %d\n", f22->olc);
	printf("omd: %d\n", f22->omd);
	printf("idot: %d\n", f22->idot);
	printf("ephaf0: %d\n", f22->ephaf0);
	printf("almhlth: %d\n", f22->almhlth);
	printf("refweek: %d\n", f22->refweek);
	printf("toa: %d\n", f22->toa);
	printf("almecc: %d\n", f22->almecc);
	printf("inclin: %d\n", f22->inclin);
	printf("rora: %d\n", f22->rora);
	printf("almaf0: %d\n", f22->almaf0);
	printf("almaf1: %d\n", f22->almaf1);
	printf("s1hlth: %d\n", f22->s1hlth);
	printf("codeL2: %d\n", f22->codeL2);
	printf("wkn: %d\n", f22->wkn);
	printf("L2Pdata: %d\n", f22->L2Pdata);
	printf("ura: %d\n", f22->ura);
	printf("iodc: %d\n", f22->iodc);
	printf("tocwk: %d\n", f22->tocwk);
	printf("iode: %d\n", f22->iode);
	printf("toewk: %d\n", f22->toewk);
	printf("fti: %d\n", f22->fti);
	printf("toe: %d\n", f22->toe);
	printf("toc: %d\n", f22->toc);
	printf("cuc: %d\n", f22->cuc);
	printf("cus: %d\n", f22->cus);
	printf("cic: %d\n", f22->cic);
	printf("cis: %d\n", f22->cis);
	printf("crc: %d\n", f22->crc);
	printf("crs: %d\n", f22->crs);
	printf("ephafl: %d\n", f22->ephafl);
	printf("af2: %d\n", f22->af2);
	printf("tgd: %d\n", f22->tgd);
	printf("deltan: %d\n", f22->deltan);
	printf("satID: %d\n", f22->satID);
	printf("almvflg: %d\n", f22->almvflg);
	printf("ephvflg: %d\n", f22->ephvflg);
}

void print_gps_f23(gps_f23 *f23)
{
	uint8 x;

	printf("a: ");
	for (x = 0; x < 4; x++)
		printf("%f ", f23->a[x]);
	printf("\n");

	printf("b: ");
	for (x = 0; x < 4; x++)
		printf("%f ", f23->b[x]);
	printf("\n");
	printf("A: %f %f\n", f23->A[0], f23->A[1]);
	printf("tot: %d\n", f23->tot);
	printf("dtls: %d\n", f23->dtls);
	printf("dn: %d\n", f23->dn);
	printf("dtlsf: %d\n", f23->dtlsf);
	printf("wnt: %d\n", f23->wnt);
	printf("wnlsf: %d\n", f23->wnlsf);
	printf("ionvflg: %d\n", f23->ionvflg);
}

void print_gps_f24(gps_f24* f24)
{
	printf("refweek: %f\n", f24->refweek);
	printf("toa: %f\n", f24->toa);
	printf("ecc: %f\n", f24->ecc);
	printf("inclin: %f\n", f24->inclin);
	printf("rora: %f\n", f24->rora);
	printf("af0: %f\n", f24->af0);
	printf("af1: %f\n", f24->af1);
	printf("sqrta: %f\n", f24->sqrta);
	printf("ratoa: %f\n", f24->ratoa);
	printf("argpg: %f\n", f24->argpg);
	printf("manom: %f\n", f24->manom);
	printf("ok: %f\n", f24->ok);
}

void print_gps_telem(gps_telem *telem)
{
	printf("Volage3: %d\n", telem->voltage3);
	printf("Volage5: %d\n", telem->voltage5);
	printf("current: %d\n", telem->current);
	printf("gps_temp: %d\n", telem->gps_temp);
	printf("radio_temp: %d\n", telem->radio_temp);
	printf("last_command: %d\n", telem->last_command);
	printf("command_success: %d\n", telem->command_success);
	printf("last_satellite: %d\n", telem->last_satellite);
}

/*
 * The following functions are to aid in the parsing
 * of the sun packet's data field
 */
gps_f00 *getF00_gps(gps_packet *p)
{
	return (gps_f00*)p->data;
}

gps_f03 *getF03_gps(gps_packet *p)
{
	return (gps_f03*)p->data;
}

gps_f18 *getF18_gps(gps_packet *p)
{
	return (gps_f18*)p->data;
}

gps_f22 *getF22_gps(gps_packet *p)
{
	return (gps_f22*)p->data;
}

gps_f23 *getF23_gps(gps_packet *p)
{
	return (gps_f23*)p->data;
}

gps_f24 *getF24_gps(gps_packet *p)
{
	return (gps_f24*)p->data;
}

/*
 * The following are debugging functions, they print
 * the values of each channel's field to a file pointer
 */
void print_gps_packet(gps_packet *p)
{
	printf("Sentence: %s\n", p->sentence);

	if (strncmp((sint8*)p->sentence, "00", 2) == 0)
		print_gps_f00(getF00_gps(p));
	if (strncmp((sint8*)p->sentence, "03", 2) == 0)
		print_gps_f03(getF03_gps(p));
	if (strncmp((sint8*)p->sentence, "18", 2) == 0)
		print_gps_f18(getF18_gps(p));
	if (strncmp((sint8*)p->sentence, "22", 2) == 0)
		print_gps_f22(getF22_gps(p));
	if (strncmp((sint8*)p->sentence, "23", 2) == 0)
		print_gps_f23(getF23_gps(p));
	if (strncmp((sint8*)p->sentence, "24", 2) == 0)
		print_gps_f24(getF24_gps(p));
}
